diff --git a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
index 7f70fb9d0..baa93cde0 100644
--- a/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
+++ b/src/main/java/net/minecraft/client/render/texture/stitcher/IconCoordinate.java
@@ -28,7 +28,8 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         this.namespaceId = namespaceId;
         this.sourceImage = sourceImage;
     }
-    protected void setImage(BufferedImage image){
+    protected void setImage(@NotNull BufferedImage image){
+        assert image != null : "setImage cannot take null!";
         this.pendingDimensions = true;
         this._imageStorage = image;
     }
@@ -59,6 +60,7 @@ public class IconCoordinate implements Comparable<IconCoordinate> {
         return width * height;
     }
     protected void drawToAtlas(Graphics2D atlas){
+        assert _imageStorage != null : "Image storage should not be null!! something went wrong with image '" + namespaceId + "' at '" + sourceImage + "'!";
         if (width != _imageStorage.getWidth() || height != _imageStorage.getHeight()) {
             int[] subImage = _imageStorage.getRGB(0, 0, width, height, null, 0, width);
             BufferedImage _img = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
diff --git a/src/main/java/net/minecraft/client/sound/SoundEngine.java b/src/main/java/net/minecraft/client/sound/SoundEngine.java
index 41ff4cf9c..c20b8064d 100644
--- a/src/main/java/net/minecraft/client/sound/SoundEngine.java
+++ b/src/main/java/net/minecraft/client/sound/SoundEngine.java
@@ -10,6 +10,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.client.option.GameSettings;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 import paulscode.sound.SoundSystem;
 import paulscode.sound.SoundSystemConfig;
@@ -20,7 +21,7 @@ public class SoundEngine
 {
 	private static final Logger LOGGER = LogUtils.getLogger();
   private static final int MUSIC_INTERVAL = 6000;
-	private static SoundSystem soundSystem;
+	private static @Nullable SoundSystem soundSystem;
 	private static boolean loaded = false;
 
 	public static final String BG_MUSIC = "BgMusic";
@@ -40,7 +41,7 @@ public class SoundEngine
     }
 
 	public void destroy() {
-		if (loaded) {
+		if (loaded && soundSystem != null) {
 			soundSystem.cleanup();
 		}
 	}
@@ -199,6 +200,9 @@ public class SoundEngine
 	}
 
 	public void playSoundWithIdAtPos(SoundEntry entry, SoundCategory category, float x, float y, float z, float volume, final float pitch, String soundID) {
+		if (!loaded || muted || soundSystem == null || !SoundCategoryHelper.isAnyEnabled(options)) {
+			return;
+		}
 		if (entry != null) {
 			float soundDistance = entry.attenuationDistance;
 			if(volume > 1.0F)
@@ -271,6 +275,9 @@ public class SoundEngine
 	}
 
 	public void stopMusic() {
+		if (!loaded || soundSystem == null) {
+			return;
+		}
 		soundSystem.stop(BG_MUSIC);
 		soundSystem.stop(STREAMING);
 	}
@@ -298,7 +305,7 @@ public class SoundEngine
         }
         loaded = true;
     }
-	public static SoundSystem getSoundSystem(){
+	public static @Nullable SoundSystem getSoundSystem(){
 		return soundSystem;
 	}
 
diff --git a/src/main/java/net/minecraft/client/util/helper/Textures.java b/src/main/java/net/minecraft/client/util/helper/Textures.java
index 9de2b4a8d..1cfa4db2a 100644
--- a/src/main/java/net/minecraft/client/util/helper/Textures.java
+++ b/src/main/java/net/minecraft/client/util/helper/Textures.java
@@ -28,7 +28,7 @@ import org.slf4j.Logger;
 
 public class Textures {
 	private static final Logger LOGGER = LogUtils.getLogger();
-	public static BufferedImage missingTexture;
+	public final static BufferedImage missingTexture;
 	
 	static {
 		missingTexture = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 1a2816ff9..bd4dceb6b 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -556,8 +556,6 @@ public class Block
 
     public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
     }
-    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
-    }
 
     public void onEntityWalking(World world, int x, int y, int z, Entity entity)
     {
diff --git a/src/main/java/net/minecraft/core/block/ButtonBlock.java b/src/main/java/net/minecraft/core/block/ButtonBlock.java
index 6d0d00b53..d3eafa59f 100644
--- a/src/main/java/net/minecraft/core/block/ButtonBlock.java
+++ b/src/main/java/net/minecraft/core/block/ButtonBlock.java
@@ -2,6 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -94,9 +95,52 @@ public class ButtonBlock extends Block
         return world.isBlockNormalCube(x, y, z + 1);
     }
 
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        int orientation = -1;
+        switch (side) {
+            case BOTTOM:
+                if (world.isBlockNormalCube(x, y + 1, z)) {
+                    orientation = SIDE_TOP;
+                }
+                break;
+            case TOP:
+                if (world.isBlockNormalCube(x, y - 1, z)) {
+                    orientation = SIDE_BOTTOM;
+                }
+                break;
+            case NORTH:
+                if (world.isBlockNormalCube(x, y, z + 1)) {
+                    orientation = SIDE_SOUTH;
+                }
+                break;
+            case SOUTH:
+                if (world.isBlockNormalCube(x, y, z - 1)) {
+                    orientation = SIDE_NORTH;
+                }
+                break;
+            case WEST:
+                if (world.isBlockNormalCube(x + 1, y, z)) {
+                    orientation = SIDE_EAST;
+                }
+                break;
+            case EAST:
+                if (world.isBlockNormalCube(x - 1, y, z)) {
+                    orientation = SIDE_EAST;
+                }
+                break;
+        }
+        if (orientation == -1) {
+            orientation = getOrientation(world, x, y, z);
+        }
+        int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
+    }
+
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         int orientation = -1;
+        if (side.isHorizontal()) side = side.getOpposite();
         switch (side) {
             case BOTTOM:
                 if (world.isBlockNormalCube(x, y + 1, z)) {
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index 62dcfcfe2..8c8ebeda5 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -137,7 +137,7 @@ public class ChestBlock extends EntityBlock implements IPaintable {
 
 	@Override
 	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-		Direction direction = side.getOpposite().getDirection();
+		Direction direction = side.getDirection();
 		Type type = Type.SINGLE;
 
         if (direction == Direction.NORTH) {
diff --git a/src/main/java/net/minecraft/core/block/FarmlandBlock.java b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
index ba3fb8f88..8fbaf76fa 100644
--- a/src/main/java/net/minecraft/core/block/FarmlandBlock.java
+++ b/src/main/java/net/minecraft/core/block/FarmlandBlock.java
@@ -25,9 +25,9 @@ public class FarmlandBlock extends Block implements IBonemealable
 	public FarmlandBlock(String key, String namespaceId, int id)
 	{
 		super(key, namespaceId, id, Material.dirt);
-		setTicking(true);
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
 		withLightBlock(255);
+		setTicking(true);
 	}
 
 	public static boolean isWet(int data) {
@@ -54,6 +54,12 @@ public class FarmlandBlock extends Block implements IBonemealable
 		}
 	}
 
+	@Override
+	public int tickDelay()
+	{
+		return 60;
+	}
+
 	@Override
 	public AABB getCollisionBoundingBoxFromPool(final WorldSource world, final int x, final int y, final int z)
 	{
@@ -112,20 +118,19 @@ public class FarmlandBlock extends Block implements IBonemealable
 		return false;
 	}
 
-	private boolean isWaterNearby(final World world, final int x, final int y, final int z)
+	private boolean isWaterNearby(final World world, final int x, final int y, final int z, int range)
 	{
-		for (int ix = x - 4; ix <= x + 4; ix++)
+		for (int x1 = x - range; x1 <= x + range; x1++)
 		{
-			for (int iy = y; iy <= y + 1; iy++)
+			for (int y1 = y - range; y1 <= y + range; y1++)
 			{
-				for (int iz = z - 4; iz <= z + 4; iz++)
+				for (int z1 = z - range; z1 <= z + range; z1++)
 				{
-					if (Block.hasTag(world.getBlockId(ix, iy, iz), BlockTags.IS_WATER))
+					if (Block.hasTag(world.getBlockId(x1, y1, z1), BlockTags.IS_WATER))
 					{
 						return true;
 					}
 				}
-
 			}
 
 		}
@@ -152,6 +157,12 @@ public class FarmlandBlock extends Block implements IBonemealable
 		}
 	}
 
+	@Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+	{
+		world.scheduleBlockUpdate(x, y, z, id, tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+	}
+
 	@Override
 	public void onNeighborBlockChange(final World world, final int x, final int y, final int z, final int blockId)
 	{
@@ -164,7 +175,37 @@ public class FarmlandBlock extends Block implements IBonemealable
 			else
 				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 
+		} else {
+			world.scheduleBlockUpdate(x, y, z, id, tickDelay() - world.rand.nextInt(10) + world.rand.nextInt(10));
+		}
+	}
+
+	private boolean canBecomeWet(final World world, final int x, final int y, final int z)
+	{
+		// If there's water within 1 block, it can become wet
+		if(isWaterNearby(world, x, y, z, 1))
+			return true;
+
+		// If there's water 3 blocks...
+		if(isWaterNearby(world, x, y, z, 4)){
+			for (int x1 = x - 1; x1 <= x + 1; x1++)
+			{
+				for (int y1 = y - 1; y1 <= y + 1; y1++)
+				{
+					for (int z1 = z - 1; z1 <= z + 1; z1++)
+					{
+						//...And the block is next to another wet mud block, it can become wet
+						int bID = world.getBlockId(x1, y1, z1);
+						if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && FarmlandBlock.isWet(world.getBlockMetadata(x1, y1, z1))))
+						{
+							return true;
+						}
+					}
+				}
+
+			}
 		}
+		return false;
 	}
 
 	@Override
@@ -175,16 +216,23 @@ public class FarmlandBlock extends Block implements IBonemealable
 
 	@Override
 	public void updateTick(final World world, final int x, final int y, final int z, final Random rand) {
-		if (rand.nextInt(5) == 0) {
-			int data = world.getBlockMetadata(x, y, z);
-			if (isWaterNearby(world, x, y, z) || world.canBlockBeRainedOn(x, y + 1, z)) {
-				world.setBlockMetadataWithNotify(x, y, z, setWet(data, getWet(data) - 1));
-			} else {
-				if (isWet(data)) {
-					world.setBlockMetadataWithNotify(x, y, z, setWet(data, 0));
-				} else if (!isCropsNearby(world, x, y, z)) {
-					world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
-				}
+		if (rand.nextInt(2) != 0) {
+			world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+			return;
+		}
+		int data = world.getBlockMetadata(x, y, z);
+		int hydration = getWet(data);
+		if (isWaterNearby(world, x, y, z, 4) || world.canBlockBeRainedOn(x, y + 1, z)) {
+			if (hydration < 15 && canBecomeWet(world, x, y, z)) {
+				world.setBlockMetadataWithNotify(x, y, z, setWet(data, hydration + 1));
+				world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+			}
+		} else {
+			if (hydration > 0) {
+				world.setBlockMetadataWithNotify(x, y, z, setWet(data, hydration - 1));
+				world.scheduleBlockUpdate(x, y, z, id, tickDelay() - rand.nextInt(10) + rand.nextInt(10));
+			} else if (!isCropsNearby(world, x, y, z)) {
+				world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
 			}
 		}
 	}
diff --git a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
index 5d3947869..cd1a70b42 100644
--- a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
@@ -23,9 +23,7 @@ public abstract class FullRotatableBlock extends Block {
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        final Direction direction = side.getOpposite().getDirection();
-
-        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(side.getDirection()));
     }
 
     public static int directionToMeta(Direction direction) {
@@ -35,11 +33,4 @@ public abstract class FullRotatableBlock extends Block {
     public static Direction metaToDirection(int meta) {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
-
-    @Override
-    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
-    {
-        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
-        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/LeverBlock.java b/src/main/java/net/minecraft/core/block/LeverBlock.java
index 5f1b849cf..62e0a9e9b 100644
--- a/src/main/java/net/minecraft/core/block/LeverBlock.java
+++ b/src/main/java/net/minecraft/core/block/LeverBlock.java
@@ -123,7 +123,7 @@ public class LeverBlock extends Block
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPowered = isPowered(meta);
         int rotation = -1;
-        switch (side){
+        switch (side.getOpposite()){
             case BOTTOM:
                 if (world.canPlaceOnSurfaceOfBlock(x, y + 1, z)){
                     rotation = ROTATION_BOTTOM_NS;
diff --git a/src/main/java/net/minecraft/core/block/MudBlock.java b/src/main/java/net/minecraft/core/block/MudBlock.java
index 920a9d5bf..ac605af30 100644
--- a/src/main/java/net/minecraft/core/block/MudBlock.java
+++ b/src/main/java/net/minecraft/core/block/MudBlock.java
@@ -86,7 +86,8 @@ public class MudBlock extends Block{
                     for (int z1 = z - 1; z1 <= z + 1; z1++)
                     {
                         //...And the block is next to another wet mud block, it can become wet
-                        if (world.getBlockId(x1, y1, z1) == Blocks.MUD.id)
+                        int bID = world.getBlockId(x1, y1, z1);
+                        if (bID == Blocks.MUD.id || (bID == Blocks.FARMLAND_DIRT.id && FarmlandBlock.isWet(world.getBlockMetadata(x1, y1, z1))))
                         {
                             return true;
                         }
@@ -162,7 +163,7 @@ public class MudBlock extends Block{
     @Override
     public void updateTick(final World world, final int x, final int y, final int z, final Random rand)
     {
-        // dry out mud
+        // hydrate mud
         if(isHardened) {
             if(!isLavaNearby(world, x, y, z)) {
                 if (canBecomeWet(world, x, y, z)) {
@@ -173,6 +174,7 @@ public class MudBlock extends Block{
             }
         }
 
+        // dry out mud
         if(!isHardened){
             if(isLavaNearby(world, x, y, z) || world.dimension.id == Dimension.NETHER.id) {
                 world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, x + 0.5D, y + 0.5D, z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
diff --git a/src/main/java/net/minecraft/core/block/RotatableBlock.java b/src/main/java/net/minecraft/core/block/RotatableBlock.java
index 679dc3e81..af90e4f69 100644
--- a/src/main/java/net/minecraft/core/block/RotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableBlock.java
@@ -30,14 +30,8 @@ public abstract class RotatableBlock extends Block{
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if (!side.isHorizontal()) side = Side.NORTH;
-        world.setBlockMetadataWithNotify(x, y, z, side.getOpposite().getId());
+        if (!side.isHorizontal()) side = Side.SOUTH;
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, side.getDirection()));
     }
 
-    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
-    {
-        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
-        if (direction.getOffsetY() != 0) direction = Direction.NORTH.getOpposite();
-        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
index 30c75acb6..fd379f415 100644
--- a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
@@ -21,15 +21,7 @@ public abstract class RotatableEntityBlock extends EntityBlock {
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if (!side.isHorizontal()) side = Side.NORTH;
-        world.setBlockMetadataWithNotify(x, y, z, side.getOpposite().getId());
-    }
-
-    @Override
-    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
-    {
-        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
-        if (direction.getOffsetY() != 0) direction = Direction.NORTH.getOpposite();
-        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
+        if (!side.isHorizontal()) side = Side.SOUTH;
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, side.getDirection()));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/StairsBlock.java b/src/main/java/net/minecraft/core/block/StairsBlock.java
index da7d7c494..eb2221b80 100644
--- a/src/main/java/net/minecraft/core/block/StairsBlock.java
+++ b/src/main/java/net/minecraft/core/block/StairsBlock.java
@@ -329,8 +329,9 @@ public class StairsBlock extends Block
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
 
+        side = side.getOpposite();
         Side hSide = !side.isHorizontal() ? Side.NORTH : side;
-        Direction hRotation = side.getOpposite().getDirection();
+        Direction hRotation = hSide.getOpposite().getDirection();
         if(hRotation == Direction.NORTH) meta |= 0b0010;
         if(hRotation == Direction.EAST) meta |= 0b0001;
         if(hRotation == Direction.SOUTH) meta |= 0b0011;
diff --git a/src/main/java/net/minecraft/core/block/TorchBlock.java b/src/main/java/net/minecraft/core/block/TorchBlock.java
index 7d2734603..62f15f2f5 100644
--- a/src/main/java/net/minecraft/core/block/TorchBlock.java
+++ b/src/main/java/net/minecraft/core/block/TorchBlock.java
@@ -80,9 +80,48 @@ public class TorchBlock extends Block
         return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
     }
 
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        int orientation = SIDE_NONE;
+        switch (side) {
+            case TOP:
+                if(canPlaceOnTop(world, x, y - 1, z))
+                {
+                    orientation = SIDE_BOTTOM;
+                }
+                break;
+            case NORTH:
+                if(world.isBlockNormalCube(x, y, z + 1))
+                {
+                    orientation = SIDE_SOUTH;
+                }
+                break;
+            case SOUTH:
+                if(world.isBlockNormalCube(x, y, z - 1))
+                {
+                    orientation = SIDE_NORTH;
+                }
+                break;
+            case WEST:
+                if(world.isBlockNormalCube(x + 1, y, z))
+                {
+                    orientation = SIDE_EAST;
+                }
+                break;
+            case EAST:
+                if(world.isBlockNormalCube(x - 1, y, z))
+                {
+                    orientation = SIDE_WEST;
+                }
+                break;
+        }
+        world.setBlockMetadataWithNotify(x, y, z, orientation);
+    }
+
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         int orientation = SIDE_NONE;
+        if (side.isHorizontal()) side = side.getOpposite();
         switch (side) {
             case TOP:
                 if(canPlaceOnTop(world, x, y - 1, z))
diff --git a/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
index 8039803b6..468a7b450 100644
--- a/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/VeryRotatableEntityBlock.java
@@ -5,7 +5,6 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class VeryRotatableEntityBlock extends RotatableEntityBlock {
@@ -18,28 +17,20 @@ public abstract class VeryRotatableEntityBlock extends RotatableEntityBlock {
     public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
         final Direction direction = mob.getPlacementDirection(side).getOpposite();
 
-        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+        world.setBlockMetadataWithNotify(x, y, z, setDirection(0, direction));
     }
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        final Direction direction = side.getOpposite().getDirection();
-
-        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+        world.setBlockMetadataWithNotify(x, y, z, setDirection(0, side.getDirection()));
     }
 
-    public static int directionToMeta(Direction direction) {
-        return direction.getId() & MASK_DIRECTION;
+    public static int setDirection(int meta, Direction direction) {
+        return (meta & ~MASK_DIRECTION) | (direction.getId() & MASK_DIRECTION);
     }
 
     public static Direction metaToDirection(int meta) {
         return Direction.getDirectionById(meta & MASK_DIRECTION);
     }
 
-    @Override
-    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
-    {
-        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
-        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
-    }
 }
diff --git a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
index de25b0b39..ca052330d 100644
--- a/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/PistonBaseBlock.java
@@ -56,7 +56,7 @@ public class PistonBaseBlock extends Block
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        Direction placementDirection = side.getOpposite().getDirection();
+        Direction placementDirection = side.getDirection();
         world.setBlockMetadataWithNotify(x, y, z, placementDirection.getId());
         if(!world.isClientSide)
         {
diff --git a/src/main/java/net/minecraft/core/item/block/BlockItem.java b/src/main/java/net/minecraft/core/item/block/BlockItem.java
index 7cfa18ea0..99910e11a 100644
--- a/src/main/java/net/minecraft/core/item/block/BlockItem.java
+++ b/src/main/java/net/minecraft/core/item/block/BlockItem.java
@@ -72,9 +72,7 @@ public class BlockItem extends Item
         int z = blockZ + direction.getOffsetZ();
         Block b = world.getBlock(x, y, z);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            if (onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5)) {
-                getBlock().onBlockPlacedByActivator(world, x, y, z, activatorBlock, direction);
-            }
+            onUseItemOnBlock(itemStack, null, world, x, y, z, direction.getSide(), 0.5, 0.5);
         }
     }
 
